declare const nestedProperty: {
    /**
     * Sets the value at path of object. If a portion of path doesn’t exist it’s created.
     *
     * @param object The object to modify.
     * @param path The path of the property to set.
     * @param value The value to set.
     */
    set<T extends Record<string, any>>(obj: T, path: string, value: any): void;
    /**
     * Gets the property value at path of object.
     *
     * @param object The object to query.
     * @param path The path of the property to get.
     * @return Returns the resolved value.
     */
    get<TObj extends Record<string, any>, TVal>(obj: TObj, path: string): TVal | undefined;
};
export default nestedProperty;
